if ( not archmage ) then archmage = {} end
archmage.lmines = {}

function archmage.conv_angle(a)
	return (a + 270) % 360
end

function archmage.dist(...)
	if ( #arg == 2 ) then
		-- assume two table params
		return math.sqrt( (arg[2][1] - arg[1][1])^2 + (arg[2][2] - arg[1][2])^2 )
	else
		-- assume four numercial params
		return math.sqrt( (arg[3] - arg[1])^2 + (arg[4] - arg[2])^2 )
	end
end

function archmage.freeline(x, y, x2, y2)
	local a = math.atan2(y2-y, x2-x)
	local d = math.floor(archmage.dist(x, y, x2, y2))
	local i = 1
	while ( i <= d ) do
		if ( i > 1000 ) then
			return false
		end
		local x_ = x+math.cos(a)*i
		local y_ = y+math.sin(a)*i
		if ( tile(math.floor(x_/32), math.floor(y_/32), "wall") ) then
			return false
		end
		i = i + 16
	end
	return true
end

function archmage.build(id, typ, x, y, mode, oid)
	if ( typ == 21 ) then -- laser mine
		archmage.lmines[#archmage.lmines+1] = {id, x*32+16, y*32+16, oid}
	end
end
addhook("build", "archmage.build")

function archmage.attack(id)
	local x, y, rot = player(id, "x"), player(id, "y"), player(id, "rot")
	rot = archmage.conv_angle(rot)%360
	local wp = player(id, "weapontype")
	local t = math.floor(wp/10)
	if ( t < 5 ) then
		for k, v in ipairs(archmage.lmines) do
			local dist = archmage.dist(v[2], v[3], x, y)
			local angle = math.atan2( (v[3]-y)/dist, (v[2]-x)/dist )
			angle = math.deg(angle) % 360
			if ( math.abs(rot - angle) <= 2.5 ) then
				if ( archmage.freeline(x, y, v[2], v[3]) ) then
					parse("explosion "..v[2].." "..v[3].." 10 1 0")
					table.remove(archmage.lmines, k)
					break
				end
			end
		end
	end
end
addhook("attack", "archmage.attack")